#ifndef _MALLOC_H
#define _MALLOC_H

/* malloc.h - private header for memory allocation definitions */

#if __POCC__ >= 500
#pragma once
#endif

#pragma message("Use <stdlib.h> instead of non-standard <malloc.h>")

/* type definitions */
#ifndef _SIZE_T_DEFINED
#define _SIZE_T_DEFINED
#if __POCC_TARGET__ == 3
typedef unsigned long long size_t;
#else
typedef unsigned int size_t;
#endif
#endif /* _SIZE_T_DEFINED */

/* declarations */
void * __cdecl _alloca(size_t);
void * __cdecl calloc(size_t, size_t);
void __cdecl free(void *);
void * __cdecl malloc(size_t);
void * __cdecl realloc(void *, size_t);
size_t __cdecl _msize(void *);
int __cdecl _heap_validate(void *);

#ifdef __POCC__OLDNAMES
#undef alloca
#define alloca  _alloca
#endif /* __POCC__OLDNAMES */

#endif /* _MALLOC_H */


