#ifndef _COMPLEX_H
#define _COMPLEX_H

/* complex.h - C99 standard header */

#if __POCC__ >= 500
#pragma once
#endif

/* macros */
#define complex  _Complex
#define _Complex_I  ((const float _Complex)__I__)
#define I  _Complex_I

#ifndef _WINCE

/* double declarations */
double __cdecl cabs(double complex);
double complex __cdecl cacos(double complex);
double complex __cdecl cacosh(double complex);
double __cdecl carg(double complex);
double complex __cdecl casin(double complex);
double complex __cdecl casinh(double complex);
double complex __cdecl catan(double complex);
double complex __cdecl catanh(double complex);
double complex __cdecl ccos(double complex);
double complex __cdecl ccosh(double complex);
double complex __cdecl cexp(double complex);
double __cdecl cimag(double complex);
double complex __cdecl clog(double complex);
double complex __cdecl conj(double complex);
double complex __cdecl cpow(double complex, double complex);
double complex __cdecl cproj(double complex);
double __cdecl creal(double complex);
double complex __cdecl csin(double complex);
double complex __cdecl csinh(double complex);
double complex __cdecl csqrt(double complex);
double complex __cdecl ctan(double complex);
double complex __cdecl ctanh(double complex);

/* float declarations */
float __cdecl cabsf(float complex);
float complex __cdecl cacosf(float complex);
float complex __cdecl cacoshf(float complex);
float __cdecl cargf(float complex);
float complex __cdecl casinf(float complex);
float complex __cdecl casinhf(float complex);
float complex __cdecl catanf(float complex);
float complex __cdecl catanhf(float complex);
float complex __cdecl ccosf(float complex);
float complex __cdecl ccoshf(float complex);
float complex __cdecl cexpf(float complex);
float __cdecl cimagf(float complex);
float complex __cdecl clogf(float complex);
float complex __cdecl conjf(float complex);
float complex __cdecl cpowf(float complex, float complex);
float complex __cdecl cprojf(float complex);
float __cdecl crealf(float complex);
float complex __cdecl csinf(float complex);
float complex __cdecl csinhf(float complex);
float complex __cdecl csqrtf(float complex);
float complex __cdecl ctanf(float complex);
float complex __cdecl ctanhf(float complex);

/* long double declarations */
long double __cdecl cabsl(long double complex);
long double complex __cdecl cacosl(long double complex);
long double complex __cdecl cacoshl(long double complex);
long double __cdecl cargl(long double complex);
long double complex __cdecl casinl(long double complex);
long double complex __cdecl casinhl(long double complex);
long double complex __cdecl catanl(long double complex);
long double complex __cdecl catanhl(long double complex);
long double complex __cdecl ccosl(long double complex);
long double complex __cdecl ccoshl(long double complex);
long double complex __cdecl cexpl(long double complex);
long double __cdecl cimagl(long double complex);
long double complex __cdecl clogl(long double complex);
long double complex __cdecl conjl(long double complex);
long double complex __cdecl cpowl(long double complex, long double complex);
long double complex __cdecl cprojl(long double complex);
long double __cdecl creall(long double complex);
long double complex __cdecl csinl(long double complex);
long double complex __cdecl csinhl(long double complex);
long double complex __cdecl csqrtl(long double complex);
long double complex __cdecl ctanl(long double complex);
long double complex __cdecl ctanhl(long double complex);

#endif /* _WINCE */

#endif /* _COMPLEX_H */
