#ifndef _CONIO_H
#define _CONIO_H

/* conio.h - private header for console I/O definitions */

#if __POCC__ >= 500
#pragma once
#endif

#ifndef _WINCE

#ifndef _WCHAR_T_DEFINED
#define _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
#endif

#ifndef _WINT_T_DEFINED
#define _WINT_T_DEFINED
typedef unsigned short wint_t;
#endif /* _WINT_T_DEFINED */

#ifdef _CONIO_RETRO_COLORS
#define BLACK  0
#define BLUE  1
#define GREEN  2
#define CYAN  3
#define RED  4
#define MAGENTA  5
#define BROWN  6
#define LIGHTGRAY  7
#define DARKGRAY  8
#define LIGHTBLUE  9
#define LIGHTGREEN  10
#define LIGHTCYAN  11
#define LIGHTRED  12
#define LIGHTMAGENTA  13
#define YELLOW  14
#define WHITE  15
#endif /* _CONIO_RETRO_COLORS */

/* declarations */
char * __cdecl _cgets(char *);
void __cdecl _clreol(void);
void __cdecl _clrscr(void);
int __cdecl _cprintf(const char * restrict, ...);
int __cdecl _cputs(const char *);
int __cdecl _cscanf(const char * restrict, ...);
int __cdecl _cwprintf(const wchar_t * restrict, ...);
int __cdecl _getch(void);
int __cdecl _getche(void);
void __cdecl _gotoxy(int, int);
int __cdecl _inp(unsigned short);
unsigned short __cdecl _inpw(unsigned short);
unsigned long __cdecl _inpd(unsigned short);
int __cdecl _kbhit(void);
int __cdecl _outp(unsigned short, int);
unsigned short __cdecl _outpw(unsigned short, unsigned short);
unsigned long __cdecl _outpd(unsigned short, unsigned long);
int __cdecl _putch(int);
wint_t __cdecl _putwch(wchar_t);
void __cdecl _textbackground(int);
void __cdecl _textcolor(int);
int __cdecl _ungetch(int);
int __cdecl _wherex(void);
int __cdecl _wherey(void);

/* compatibility names */
#ifdef __POCC__OLDNAMES
char * __cdecl cgets(char *);
void __cdecl clreol(void);
void __cdecl clrscr(void);
int __cdecl cprintf(const char * restrict, ...);
int __cdecl cputs(const char *);
int __cdecl cscanf(const char * restrict, ...);
int __cdecl getch(void);
int __cdecl getche(void);
void __cdecl gotoxy(int, int);
int __cdecl inp(unsigned short);
unsigned short __cdecl inpw(unsigned short);
int __cdecl kbhit(void);
int __cdecl outp(unsigned short, int);
unsigned short __cdecl outpw(unsigned short, unsigned short);
int __cdecl putch(int);
void __cdecl textbackground(int);
void __cdecl textcolor(int);
int __cdecl ungetch(int);
int __cdecl wherex(void);
int __cdecl wherey(void);
#endif /* __POCC__OLDNAMES */

#else /* _WINCE */

#pragma message("<conio.h> included - but no console mode on WinCE!")

#endif  /* _WINCE */

#endif /* _CONIO_H */
