#ifndef _OMP_H
#define _OMP_H

/* omp.h - OpenMP 2.5 header (stubs only) */

#if __POCC__ >= 500
#pragma once
#endif

#ifndef _WINCE

/* Not really supported, so separate from the C runtime... */
#pragma comment(lib, "omp.lib")

#ifndef __CRTBUILD__
#pragma message("<omp.h> with stubs only...")
#endif /* __CRTBUILD__ */

/* type definitions */
#ifndef OMP_LOCK_T
#define OMP_LOCK_T
typedef struct omp_lock_t omp_lock_t;
#endif /* OMP_LOCK_T */

#ifndef OMP_NEST_LOCK_T
#define OMP_NEST_LOCK_T
typedef struct omp_nest_lock_t omp_nest_lock_t;
#endif /* OMP_NEXT_LOCK_T */

/* execution environment functions */
void __cdecl omp_set_num_threads(int);
int __cdecl omp_get_num_threads(void);
int __cdecl omp_get_max_threads(void);
int __cdecl omp_get_thread_num(void);
int __cdecl omp_get_num_procs(void);
int __cdecl omp_in_parallel(void);
void __cdecl omp_set_dynamic(int);
int __cdecl omp_get_dynamic(void);
void __cdecl omp_set_nested(int);
int __cdecl omp_get_nested(void);

/* lock functions */
void __cdecl omp_init_lock(omp_lock_t *);
void __cdecl omp_destroy_lock(omp_lock_t *);
void __cdecl omp_set_lock(omp_lock_t *);
void __cdecl omp_unset_lock(omp_lock_t *);
int __cdecl omp_test_lock(omp_lock_t *);

void __cdecl omp_init_nest_lock(omp_nest_lock_t *);
void __cdecl omp_destroy_nest_lock(omp_nest_lock_t *);
void __cdecl omp_set_nest_lock(omp_nest_lock_t *);
void __cdecl omp_unset_nest_lock(omp_nest_lock_t *);
int __cdecl omp_test_nest_lock(omp_nest_lock_t *);

/* timing routines */
double __cdecl omp_get_wtime(void);
double __cdecl omp_get_wtick(void);

#endif /* _WINCE */

#endif /* _OMP_H */
