#ifndef _STRING_H
#define _STRING_H

/* string.h - C99 standard header */

#if __POCC__ >= 500
#pragma once
#endif

/* macros */
#ifndef NULL
#define NULL  ((void *)0)
#endif

/* type definitions */
#ifndef _SIZE_T_DEFINED
#define _SIZE_T_DEFINED
#if __POCC_TARGET__ == 3
typedef unsigned long long size_t;
#else
typedef unsigned int size_t;
#endif
#endif /* _SIZE_T_DEFINED */

/* declarations */
void * __cdecl memchr(const void *, int, size_t);
int __cdecl memcmp(const void *, const void *, size_t);
void * __cdecl memcpy(void * restrict, const void * restrict, size_t);
void * __cdecl memmove(void *, const void *, size_t);
void * __cdecl memset(void *, int, size_t);
char * __cdecl strcat(char * restrict, const char * restrict);
char * __cdecl strchr(const char *, int);
int __cdecl strcmp(const char *, const char *);
char * __cdecl strcpy(char * restrict, const char * restrict);
size_t __cdecl strcspn(const char *, const char *);
size_t __cdecl strlen(const char *);
char * __cdecl strncat(char * restrict, const char * restrict, size_t);
int __cdecl strncmp(const char *, const char *, size_t);
char * __cdecl strncpy(char * restrict, const char * restrict, size_t);
char * __cdecl strpbrk(const char *, const char *);
char * __cdecl strrchr(const char *, int);
size_t __cdecl strspn(const char *, const char *);
char * __cdecl strstr(const char *, const char *);
char * __cdecl strtok(char * restrict, const char * restrict);
#ifndef _WINCE
int __cdecl strcoll(const char *, const char *);
char * __cdecl strerror(int);
size_t __cdecl strxfrm(char * restrict, const char * restrict, size_t);
#endif /* _WINCE */

/* private extensions to standard C */
int __cdecl _memicmp(const void *, const void *, size_t);
char * __cdecl _strdup(const char *);
int __cdecl _stricmp(const char *, const char *);
char * __cdecl _strlwr(char *);
int __cdecl _strnicmp(const char *, const char *, size_t);
char * __cdecl _strnset(char *, int, size_t);
char * __cdecl _strrev(char *);
char * __cdecl _strupr(char *);
#ifndef _WINCE
void * __cdecl _memichr(const void *, int, size_t);
char * __cdecl _strichr(const char *, int);
char * __cdecl _stristr(const char *, const char *);
char * __cdecl _strrichr(const char *, int);
#endif /* _WINCE */

/* compatibility names */
#ifdef __POCC__OLDNAMES
int __cdecl memicmp(const void *, const void *, size_t);
char * __cdecl strdup(const char *);
int __cdecl stricmp(const char *, const char *);
char * __cdecl strlwr(char *);
int __cdecl strnicmp(const char *, const char *, size_t);
char * __cdecl strnset(char *, int, size_t);
char * __cdecl strrev(char *);
char * __cdecl strupr(char *);
#endif /* __POCC__OLDNAMES */

/* more secure C functions (TR24731-1) */
#if __STDC_WANT_LIB_EXT1__ && !defined(_WINCE)

#ifndef _ERRNO_T_DEFINED
#define _ERRNO_T_DEFINED
typedef int errno_t;
#endif /* _ERRNO_T_DEFINED */

#ifndef _RSIZE_T_DEFINED
#define _RSIZE_T_DEFINED
#if __POCC_TARGET__ == 3
typedef unsigned long long rsize_t;
#else
typedef unsigned int rsize_t;
#endif
#endif /* _RSIZE_T_DEFINED */

/* declarations */
errno_t __cdecl memcpy_s(void * restrict, rsize_t, const void * restrict, rsize_t);
errno_t __cdecl memmove_s(void *, rsize_t, const void *, rsize_t);
errno_t __cdecl strcpy_s(char * restrict, rsize_t, const char * restrict);
errno_t __cdecl strncpy_s(char * restrict, rsize_t, const char * restrict, rsize_t);
errno_t __cdecl strcat_s(char * restrict, rsize_t, const char * restrict);
errno_t __cdecl strncat_s(char * restrict, rsize_t, const char * restrict, rsize_t);
char * __cdecl strtok_s(char * restrict, rsize_t * restrict, const char * restrict, char ** restrict);
errno_t __cdecl strerror_s(char *, rsize_t, errno_t);
size_t __cdecl strerrorlen_s(errno_t);
size_t __cdecl strnlen_s(const char *, size_t);

#endif /* __STDC_WANT_LIB_EXT1__ */

#endif /* _STRING_H */
